// This may look like C code, but it is really -*- C++ -*-
//
// this class definition is for use with large systems (very large integer)
// most significant bits ly in vlint[max] ??
//
// history:
// - 1st version Apr02 
// ToDo:
//

#ifndef __cplusplus
#error "We need c++ here!"
#endif

#ifndef B2size
#error B2size must be defined here
#endif
// use together with: typedef class vlint tbase1

#ifndef _Vlint_h
#ifdef __GNUG__
/* #pragma interface */
#endif
#define _Vlint_h 1

class vlint
{
public:

  unsigned int    a[B2size];

// public:

//                vlint(const vlint& y); // ???
                  vlint(int y=0);

                  ~vlint();

// vlint&         operator =  (const vlint& y);  // predefined
// vlint&         operator =  (const int& y);    // implicite: =(vlint)y
   vlint&         operator ^= (const vlint& y);
   vlint&         operator |= (const vlint& y);
   vlint&         operator &= (const vlint& y);
   vlint&         operator >>= (const int& y);
   vlint&         operator <<= (const int& y);

// vlint&         operator ^ (const vlint& x, const vlint& y);
// vlint&         operator | (const vlint& x, const vlint& y);
// vlint&         operator & (const vlint& x, const vlint& y);

// vlint&         operator >> (const vlint& x, int& y); 
// vlint&         operator << (const vlint& x, int& y); 
// bool&          operator >= (const vlint& x, const vlint& y); 
// bool&          operator <= (const vlint& x, const vlint& y); 
// bool&          operator == (const vlint& x, const vlint& y); 
// bool&          operator <  (const vlint& x, const vlint& y); 

                  /* ToDo: check for a[1..B2size]==0 */
//                  operator int() const {
// int t=0; for(int i=1;i<B2size;i++) t|=a[i];
// if (t) { printf("error: tbase_value to big, can not be casted to int\n"); }
//                   return a[0]; }
// leads to ambiguous results: ToDo: only for explixit casts?
//  ex:  vlint ^ int == int(vlint) ^ int == vlint ^ vlint(int)

};

// function

inline void pout(const vlint& x){
  for(int i=0;i<B2size;i++) printf(" %08x",x.a[B2size-i-1]);
  printf("\n");
}

// inline members

// inline vlint::vlint(const vlint& y) :a(y.a) {} // ???
inline vlint::vlint(int y) {
 for (int i=1;i<B2size;i++) a[i]=0; a[0]=y;
}

inline vlint::~vlint() {}

// cast-op. is similar to constructor!
// inline vlint::operator int() const { return a[0]; }

// inline vlint&  vlint::operator =  (const vlint& y) 
// { int i; for(i=0;i<B2size;i++) a[i] = y.a[i]; return *this; } 


inline vlint&  vlint::operator ^= (const vlint& y){
 for(int i=0;i<B2size;i++) a[i]^=y.a[i];
 return *this;
}

inline vlint&  vlint::operator |= (const vlint& y){
 for(int i=0;i<B2size;i++) a[i]|=y.a[i];
 return *this;
}

inline vlint&  vlint::operator &= (const vlint& y){
 for(int i=0;i<B2size;i++) a[i]&=y.a[i];
 return *this;
}

/* y should be never greater than B2size*8*sizeof(int)! */
inline vlint&  vlint::operator >>= (const int& y){
  class vlint t;
  int i, si=y/(8*sizeof(int)), ri=y%(8*sizeof(int));
  if (si>B2size) { si=B2size; ri=0; }
  for(i=B2size-si;i<B2size;i++) t.a[i]=0;
  for(i=0   ;i<B2size-si  ;i++) t.a[i] =a[i+si  ]>>ri;
  if(ri)
  for(i=0   ;i<B2size-si-1;i++) t.a[i]|=a[i+si+1]<<(8*sizeof(int)-ri);
//  printf(">>=%d\n",y);pout(*this);pout(t);
  for(i=0;i<B2size;i++) a[i]=t.a[i];
  return *this;
}

inline vlint&  vlint::operator <<= (const int& y){
  class vlint t;
  int i, si=y/(8*sizeof(int)), ri=y%(8*sizeof(int));
  if (si>B2size) { si=B2size; ri=0; }
  for(i=0   ;i<si    ;i++) t.a[i]=0;
  for(i=si  ;i<B2size;i++) t.a[i] =a[i-si  ]<<ri;
  if(ri)
  for(i=si+1;i<B2size;i++) t.a[i]|=a[i-si-1]>>(8*sizeof(int)-ri);
//  printf("<<=%d\n",y);pout(*this);pout(t);
  for(i=0;i<B2size;i++) a[i]=t.a[i];
  return *this;
}

//  functions

inline bool operator == (const vlint& x, const vlint& y){
  for(int i=0;i<B2size;i++) if(x.a[i]!=y.a[i]) return false; return true; }

inline bool operator != (const vlint& x, const vlint& y){
  for(int i=0;i<B2size;i++) if(x.a[i]!=y.a[i]) return true; return false; }

inline bool operator < (const vlint& x, const vlint& y){
  for(int i=B2size-1;i>=0;i--){
    if(x.a[i]<y.a[i]) return true;
    if(x.a[i]>y.a[i]) return false;
  }
  return false; 
}

inline bool operator > (const vlint& x, const vlint& y){
  for(int i=B2size-1;i>=0;i--){
    if(x.a[i]<y.a[i]) return false;
    if(x.a[i]>y.a[i]) return true;
  }
  return false; 
}

inline bool operator <= (const vlint& x, const vlint& y){
  for(int i=B2size-1;i>=0;i--){
    if(x.a[i]<y.a[i]) return true;
    if(x.a[i]>y.a[i]) return false;
  }
  return true; 
}

/* SGIs MIPSpro Compilers CC Bug: for(int i) only once! */
inline vlint operator << (const vlint& x, const int& y){
  class vlint t;
  int i, si=y/(8*sizeof(int)), ri=y%(8*sizeof(int));
  if (si>B2size) { return (vlint)0; }
  for(i=0   ;i<si    ;i++) t.a[i]=0;
  for(i=si  ;i<B2size;i++) t.a[i] =x.a[i-si  ]<<ri;
  if(ri)
  for(i=si+1;i<B2size;i++) t.a[i]|=x.a[i-si-1]>>(8*sizeof(int)-ri);
  // printf("<<%d\n",y);pout(x);pout(t);
  return t;
}

inline vlint operator >> (const vlint& x, const int& y){
  class vlint t;
  int i, si=y/(8*sizeof(int)), ri=y%(8*sizeof(int));
  if (si>B2size) { return (vlint)0; }
  for(i=B2size-si;i<B2size;i++) t.a[i]=0;
  for(i=0   ;i<B2size-si  ;i++) t.a[i] =x.a[i+si  ]>>ri;
  if(ri)
  for(i=0   ;i<B2size-si-1;i++) t.a[i]|=x.a[i+si+1]<<(8*sizeof(int)-ri);
//  printf(">>%d\n",y);pout(x);pout(t);
  return t;
}

inline vlint operator ^ (const vlint& x, const vlint& y){
  class vlint t;
  for(int i=0;i<B2size;i++) t.a[i]=x.a[i]^y.a[i];
  return t;
}

inline vlint operator & (const vlint& x, const vlint& y){
  class vlint t;
  for(int i=0;i<B2size;i++) t.a[i]=x.a[i]&y.a[i];
  return t;
}

inline int operator & (const int& x, const vlint& y){
  return y.a[0]&x;
}

inline int operator & (const vlint& x, const int& y){
  return x.a[0]&y;
}

inline vlint operator - (const vlint& x, const int& y){
  class vlint t;
  unsigned int cy=0;
  t.a[0]=x.a[0]-y; if ((unsigned int)y>x.a[0]) cy=1;
  for(int i=1;i<B2size;i++){
   t.a[i]=x.a[i]-cy;
   cy=((x.a[i])?0:1);
  }
//  printf("-%d\n",y);pout(x);pout(t);
  return t;
}

inline vlint operator | (const vlint& x, const vlint& y){
  class vlint t;
  for(int i=0;i<B2size;i++) t.a[i]=x.a[i]|y.a[i];
  return t;
}

inline vlint  operator ~ (const vlint& x){
 class vlint t(x);
 for(int i=0;i<B2size;i++) t.a[i]=~x.a[i];
 return t;
}

// /* cast operator, how to define correctly? */
// inline int  operator int() (const vlint& x){
// int t=0; for(int i=1;i<B2size;i++) t|=x.a[i];
// if (t) { printf("error: tbase_value to big, can not be casted to int\n"); }
// return t|x.a[0];
//}

#endif
